component-section
  div(slot='title') 🔃 Recursie en algoritmeontwerp
  component-section
    div(slot='title') Waarom je over recursie en algoritmeontwerp leert
    p
      | Recursie is voor algoritmes vaak erg belangrijk.
      | Recursie zorgt ervoor dat functies beknopt kunnen worden opgeschreven, en dat je over het probleem dat een algoritme moet oplossen makkelijker kan nadenken.
    p
      | Algoritmeontwerppatronen geven je inzicht in algemene manieren om een algoritme te ontwikkelen en te begrijpen.
      | Dat is een belangrijke vaardigheid zodra je uiteindelijk de standaardalgoritmes wel paraat hebt, maar geconfronteerd kan worden met nieuwe.
  component-section
    div(slot='title') Recursie
    p
      | Recursie houdt in dat een functie pas zijn waarde krijgt door zichzelf weer aan te roepen.
    p.bron
      a(href='http://jeffe.cs.illinois.edu/teaching/algorithms/book/01-recursion.pdf') Recursion
      cite(data-id='6867189/PLHZEH2X', data-label='section', data-locator='1.1-1.3')
    p
      em.term Recursie
      |
      | zie je terug in broncode als een aanroep van een functie naar zichzelf.
    p
      | Wat je met recursie kan doen kan je ook met een lus doen.
      | Zie bijvoorbeeld de implementatie van
      |
      a(href='https://rosettacode.org/wiki/Binary_search') binary search
      | .
    ol
      li
        p
          em.term Basisgeval
          |
          | (base case): hier eindigt de recursie.
      li
        p
          em.term Recursief geval
          |
          | (recursive case)
    p
      | Welk van bovenstaande gevallen van toepassing is, ligt aan de conditionele structuur (bijvoorbeeld
      |
      code.lang-java if () {} else {}
      | ).
      | Een recursie is
      |
      em.term eindig
      |
      | als het basisgeval werkelijk bereikt kan worden (dat wil zeggen, de conditie daarvoor kan waar worden).
    // TODO: Stellingen over vertaling algoritme-implementaties van recursief <-> iteratief.
    p
      | Een de looptijdfunctie van een recursief algoritme kan je wiskundig beschrijven met een
      |
      em.term recurrente betrekking
      |
      | (
      em.term recurrence
      | ).
      | De looptijdfunctie zo opschrijven is intuïtief.
      | Een ander voordeel is dat je enkele standaard wiskundige procedures kan toepassen om algoritmeanalyse te doen op basis van de looptijdfunctie, in plaats van de (ingewikkelde) recursieve broncode te moeten analyseren.
      | Zulke wiskundige algoritmeanalyse doen valt buiten de leerinhoud van ADP.
      | Maar het is wel handig om te leren om een recursieve formule als een recurrente betrekking op te schrijven.
    p
      | Ook algoritmes zelf kan je soms met een recurrente betrekking beschrijven.
      | Zie het volgende voorbeeld:
    figure
      figcaption Recurrente betrekking voor vermenigvuldigen.
      // prettier-ignore
      p
        | $$x·y = \begin{cases}
        | 0                                   &amp; \text{als } x = 0 \\
        | \lfloor x/2 \rfloor · (y + y)       &amp; \text{als } x \text{ even is} \\
        | \lfloor x/2 \rfloor · (y + y) + y   &amp; \text{als } x \text{ oneven is} \\
        | \end{cases}$$
    p
      | In het voorgaande voorbeeld is vermenigvuldigen (althans, de operator \(·\)) recursief gedefinieerd.
    ul
      li
        p
          | De betrekking is te lezen als een
          |
          code.lang-java if () {} else if {}
          | -achtige conditionele structuur.
          | De conditie staat aan de rechterkant, het conditionele blok aan de linkerkant.
      li
        p
          | In de twee gevallen anders dan het basisgeval \(x = 0\) is \(x·y\) gedefinieerd als een recursieve uitdrukking.
          | Die twee uitdrukkingen verwijzen namelijk weer naar zichzelf, door de \(·\) die er opnieuw in staat.
      li
        p
          | \(\lfloor d \rfloor\) betekent: alle cijfers achter de komma van \(d\) weggooien, om zo alleen het gehele getal voor de komma te behouden.
          | (Tussen deze haakjes mag in plaats van \(d\) iedere uitdrukking met een rationaal getal als waarde staan.)
    component-section
      div(slot='title')
        a(href='https://ans.app/digital_test/assignments/297664/routing') Recurrente betrekking (op Ans)
      component-exercise
  component-section
    div(slot='title') Algoritmeontwerp
    p
      | Een algoritme kan
      |
      em.term incrementeel
      |
      | te werk gaan.
      | Het werkt dan op één positie binnen een data(structuur).
      | Denk aan een index in een rij.
    p
      | Het eenvoudigste algoritmeontwerppatroon is
      |
      em.term brute force
      |
      | (dommekracht).
      | Brute force betekent dat een algoritme alle mogelijke paden naar een oplossing van een probleem berekent, ongeacht of het onnodig (bijvoorbeeld dubbel) werk aan het doen is.
    p
      | Een alternatief hiervoor is het verdelen van het probleem, en op meerdere posities tegelijk werken.
      | Het probleem kan dan verdeeld worden over meerdere processors en daardoor sneller worden opgelost.
      | Een ander voordeel is dat het algoritme eenvoudiger kan worden, zoals bij recursie.
      | Tot slot zou een voordeel kunnen zijn dat een deeloplossing van het probleem het mogelijk maakt een deel van de rest van het probleem links te laten liggen.
    component-section
      div(slot='title') Divide-and-conquer
      p
        | Veel problemen hebben
        |
        em.term optimale substructuur
        | : om het hele probleem op te lossen, komt erop neer dat je (steeds) kleinere deelproblemen oplost.
        | Je lost het probleem op door de deeloplossingen te combineren.
        | Merge sort is hier een voorbeeld van.
      p
        | De drie stappen van
        |
        em.term divide-and-conquer
        |
        | (verdeel en heers) zijn:
      ol
        li
          p
            em Divide
            | : opdelen probleem in delen van een datastructuur.
        li
          p
            em Conquer
            | : verder opdelen, óf als deelprobleem inderdaad klein genoeg is, oplossen.
        li
          p
            em Combine
            | : combineren van de oplossingen voor de deelproblemen.
      p
        | Hoe klein een deelprobleem wordt hangt af van het algoritme zelf.
        | Het kan bijvoorbeeld \(\frac{1}{b}\)
        sup e
        |
        | deel zijn, waarbij \(b\) bijvoorbeeld \(2\) is (dat is zo bij Merge sort).
      p
        | Misschien had je het al door: als je steeds kleinere subproblemen aan het oplossen bent, dan is recursie een natuurlijke vorm om het algoritme te ontwerpen.
      // TODO:
      //
        <p class="bron">
        <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="2.3"></cite>
        <cite data-id="6867189/GMIDVX6P" data-label="chapter" data-locator="4"></cite>
        <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="4-4.5"></cite>
        (Divide-and-Conquer)
        </p>
    component-section
      div(slot='title') Dynamic programming
      p
        em.term Dynamic programming
        |
        | is een andere manier om deeloplossingen te gebruiken dan divide-and-conquer.
        | Dynamic programming wordt gebruikt als een probleem alleen op te delen is in
        |
        em overlappende
        |
        | deelproblemen, terwijl divide-and-conquer het probleem in gescheiden deelproblemen oplost.
        | Dynamic programming wordt vaak gebruikt bij algoritmes die
        |
        em optimalisatieproblemen
        |
        | oplossen.
        | Er zijn dan meerdere oplossingen correct.
        | De oplossingen hebben een bepaalde waarde, en de
        |
        em beste
        | oplossing heeft de laagste dan wel hoogste waarde.
        | Dan zou je dynamic programming als volgt kunnen definiëren:
      ol
        li
          p Stel de structuur vast van de optimale oplossing.
        li
          p Definieer de waarde van de optimale oplossing recursief.
        li
          p Bereken een steeds optimalere oplossing bottom-up.
        li
          p Structureer de optimale oplossing.
      p
        | ‘Dynamic’ staat voor de notie dat het algoritme slim bepaalt welk deelprobleem het telkens gaat oplossen.
        | Heel wat slimmer dan brute force, tenminste!
      p
        | Ook bij sommige andersoortige algoritmes, zoals bijvoorbeeld de Rij van Fibonacci berekenen, zijn er meerdere stadia waarin het algoritme hetzelfde deelprobleem tegenkomt.
        | Dan is het efficiënter om het deelprobleem niet meermaals op te gaan lossen, en dat kan met dynamic programming.
      p
        | Het bewaren van deeloplossingen heet
        |
        em.term memoisatie
        |
        | (memoization).
        | Door deeloplossingen te bewaren, wissel je looptijd in voor geheugenruimte.
      p
        | In de volgende bron legt Gayle Laakmann McDowell uit hoe dynamic programming met memoïsatie er concreet uitziet, met een algoritme om de rij van Fibonacci te berekenen.
      p.bron Algorithms: Memoization and Dynamic Programming
      component-video(videoid='P8Xa2BitN3I', title='Algorithms: Memoization and Dynamic Programming')
      // TODO:
      //
        <p class="bron">
        <cite data-id="6867189/GMIDVX6P" data-label="page" data-locator="357-385"></cite>
        <cite data-id="6867189/GMIDVX6P" data-label="chapter" data-locator="15-15.1" data-suffix="incl. inleiding"></cite>
        <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="15.3"></cite>
        (Dynamic Programming)
        </p>
    component-section
      div(slot='title') Greediness
      p
        | Soms is het makkelijker om snel een oplossing te geven op basis van een deel van de invoerdata.
        | Welk deelprobleem het algoritme oplost (de volgorde daarvan) beïnvloedt dan wel oplossing waarop het algoritme uitkomt voor het hele probleem.
        | Toch kan het algoritme voor de optimale oplossing voor het deelprobleem gaan, in de verwachting dat dit ook leidt tot een optimale oplossing voor het hele probleem.
        | Dit heet
        |
        em.term greediness
        |
        | (gulzigheid).
      p
        | Een voorbeeld hiervan is het algoritme: geef het minimale aantal munten dat je nodig hebt als wisselgeld.
        | We kunnen de munt die het meeste waard is kiezen die niet groter is dan het verschil dat overblijft.
        | Voor dit soort problemen komt een greedy algoritme sneller op de optimale oplossing dan een dynamic programming-algoritme.
      // TODO:
      //
        <p class="bron">
        <cite data-id="6867189/GMIDVX6P"></cite>
        <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="16-16.2"></cite>
        (Greedy Algorithms)
        </p>
